Bug 1024127 - Review Request: lttv - Linux Trace Toolkit Viewer
Review Request: lttv - Linux Trace Toolkit Viewer
Status: CLOSED NEXTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
unspecified Severity medium
: ---
: ---
Assigned To: Orion Poplawski
Fedora Extras Quality Assurance
: Reopened
: 717750 (view as bug list)
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-10-28 19:08 EDT by Suchakra
Modified: 2013-11-19 00:32 EST (History)
5 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-11-19 00:32:20 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
orion: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Suchakra 2013-10-28 19:08:26 EDT
Spec URL: http://suchakra.fedorapeople.org/packages/lttv.spec
SRPM URL: http://suchakra.fedorapeople.org/packages/lttv-1.5-1.fc19.src.rpm
Description: 

LTTV or Linux Trace Toolkit Viewer is a modular stand-alone viewer for kernel and userspace traces. It can perform analysis on traces of a Linux kernel or a userspace applications instrumented with LTTng and UST.

I am a new packager and I work with the upstream team which develops LTTng. Yannick is guiding me to package lttv (which he authors). This is a fresh start based on Bug 717750

Fedora Account System Username: Suchakra
Comment 1 Christopher Meng 2013-10-28 23:19:57 EDT
1. Remove:


# Spec file for LTTV
#

Above part is useless, we all know it's the spec of LTTV.

2. Where do these manpages come from?

Source3: lttv.1
Source4: lttv.real.1
Source5: lttv-gui.1

Any reference?

3. It's better to put URL above the Source(or Source0 if you have diverse sources)

4. Please read:

https://fedoraproject.org/wiki/Packaging:Guidelines#Summary_and_description

And then change your %description.

5. Instead of writting:

%package -n lttv-devel

You can just write:

%package devel

Same in %files

6. I can see $RPM_BUILD_ROOT and ${RPM_BUILD_ROOT} in the spec, well it's not a problem, but I hope you can change them to the same one, $RPM_BUILD_ROOT. Or if you really like braces, change them to %{buildroot}

7. cp command with -a(or -p) option if you preserve the timestamp on your side when fetching it from somewhere.

8. Please leave a blank line of each entry in %changelog, this will help improve the readability.
Comment 2 Suchakra 2013-10-29 00:30:45 EDT
Thanks for the quick review Christopher :)
 
> 2. Where do these manpages come from?
> 
> Source3: lttv.1
> Source4: lttv.real.1
> Source5: lttv-gui.1
> 
> Any reference?

They are from old SRPM by the author : http://secretaire.dorsal.polymtl.ca/~ybrosseau/fedora/SRPMS/lttv-0.12.38-3.fc15.src.rpm

I have notified upstream to include them in their source. Refer : http://bugs.lttng.org/issues/656 

Also, I have updated the new spec and SRPM covering your review comments :

Spec URL: http://suchakra.fedorapeople.org/packages/lttv.spec
SRPM URL: http://suchakra.fedorapeople.org/packages/lttv-1.5-1.fc19.src.rpm
Comment 3 Christopher Meng 2013-10-29 00:39:40 EDT
Wow, wait!

%package -n devel

Wrong!

When we use %package to define a subpackage(assume we want to define a -devel package), we can use eithor:

%package devel

to define a package named: $NAME-devel

OR we can use:

%package -n $NAME-devel

to do the same thing. BUT NEVER do:

%package -n devel

as this will define a subpackage with name "devel" only, that's absolutely wrong.

Please use

%package devel
Comment 4 Christopher Meng 2013-10-29 00:40:33 EDT
Also, *.so files should be put into -devel, and *.so.* should be put into main package.
Comment 5 Christopher Meng 2013-10-29 00:41:26 EDT
*** Bug 717750 has been marked as a duplicate of this bug. ***
Comment 6 Suchakra 2013-10-29 12:11:38 EDT
Aaah! Sorry. I must have been sleepy. I should have tested stuff before updating and seen the error. Thanks for explaining me things in detail.
 
> Please use
> 
> %package devel

I'll do that and update you after incorporating other suggestions.
Comment 7 Suchakra 2013-10-30 22:29:09 EDT
Updated the new spec and SRPM covering your review comments :

Spec URL: http://suchakra.fedorapeople.org/packages/lttv.spec
SRPM URL: http://suchakra.fedorapeople.org/packages/lttv-1.5-1.fc19.src.rpm

The devel package only contain headers for now. There are no separate .so versions.
Comment 8 Orion Poplawski 2013-10-31 00:00:53 EDT
Please bump release and add a new changelog entry for each revision - even during review.
Comment 9 Christopher Meng 2013-10-31 00:15:35 EDT
BTW I think you can remove

ls -lR %{buildroot}/

As I don't understand why it presents there.
Comment 10 Orion Poplawski 2013-10-31 00:19:36 EDT
License question -

LGPL (v2.1) (with incorrect FSF address)
----------------------------------------
/var/lib/mock/fedora-rawhide-x86_64/root/builddir/build/BUILD/lttv-1.5/lttv/lttv/compiler.h
/var/lib/mock/fedora-rawhide-x86_64/root/builddir/build/BUILD/lttv-1.5/lttv/lttv/time.h

Are these left over from a license change?

Also, it would be good if the address was corrected, preferably upstream, but can be done with sed in the spec file as well.
Comment 11 Suchakra 2013-11-02 00:27:32 EDT
Updated the new spec and SRPM covering comments 8, 9 and 10 :

Spec URL: http://suchakra.fedorapeople.org/packages/lttv.spec
SRPM URL: http://suchakra.fedorapeople.org/packages/lttv-1.5-2.fc19.src.rpm

Summary of changes : 
* Bumped release
* Updated entries in changelog
* 2 new patches added based on upstream commits for licence change and FSF address change issue (http://git.lttng.org/?p=lttv.git)
* Changed AUTHORS file format to UTF-8 as required

Just for info, the only warning rpmlint shows no-documentation warning for devel which seems acceptable as per the guidelines
Comment 12 Orion Poplawski 2013-11-04 23:46:25 EST
What happened to your old changelog entry?  You should have something like:

* Sat Nov 2 2013 Suchakra Sharma <suchakra@fedoraproject.org> - 1.5-2
- Patches for licence change and incorrect FSF address
- Change AUTHORS file format to UTF-8

* Thu Oct 24 2013 Suchakra Sharma <suchakra@fedoraproject.org> - 1.5-1
- New spec based on Yannick's previous spec in Bug 717750

Do you understand what the changelog is supposed to contain?  Compare to other packages with 'rpm -q --changelog <pkgname>'.

- You need to filter the provides of the plugins - see https://fedoraproject.org/wiki/Packaging:AutoProvidesAndRequiresFiltering

- I've sponsored you.

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed

Minor -  

- you really don't need lttv-devel to require glibc-devel, that's generally assumed.
- Add --disable-silent-rules to %configure - it's good to verify the compiler arguments.

===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Development (unversioned) .so files in -devel subpackage, if present.
     Note: Unversioned so-files in private %_libdir subdirectory (see
     attachment). Verify they are not in ld path.
[x]: Header files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "GPL (v2)", "GPL (v2 or later)", "Unknown or generated". 10 files have
     unknown license. Detailed output of licensecheck in
     /export/home/orion/redhat/lttv-1.5/1024127-lttv/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[!]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 4 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package contains desktop file if it is a GUI application.
[x]: Package installs a %{name}.desktop using desktop-file-install or desktop-
     file-validate if there is such a file.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[!]: Final provides and requires are sane (see attachments).
     Need to filter out the plugins
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Patches link to upstream bugs/comments/lists or are otherwise justified.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
     no tests
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: SourceX tarball generation or download is documented.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: lttv-1.5-2.fc19.x86_64.rpm
          lttv-devel-1.5-2.fc19.x86_64.rpm
          lttv-1.5-2.fc19.src.rpm
lttv-devel.x86_64: W: no-documentation
3 packages and 0 specfiles checked; 0 errors, 1 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint lttv-devel lttv
lttv-devel.x86_64: W: no-documentation
2 packages and 0 specfiles checked; 0 errors, 1 warnings.
# echo 'rpmlint-done:'



Requires
--------
lttv-devel (rpmlib, GLIBC filtered):
    glibc-devel
    lttv(x86-64)

lttv (rpmlib, GLIBC filtered):
    /bin/sh
    libatk-1.0.so.0()(64bit)
    libbabeltrace-ctf.so.0()(64bit)
    libbabeltrace.so.0()(64bit)
    libc.so.6()(64bit)
    libcairo.so.2()(64bit)
    libfontconfig.so.1()(64bit)
    libfreetype.so.6()(64bit)
    libgdk-x11-2.0.so.0()(64bit)
    libgdk_pixbuf-2.0.so.0()(64bit)
    libgio-2.0.so.0()(64bit)
    libglib-2.0.so.0()(64bit)
    libgmodule-2.0.so.0()(64bit)
    libgobject-2.0.so.0()(64bit)
    libgtk-x11-2.0.so.0()(64bit)
    libm.so.6()(64bit)
    libpango-1.0.so.0()(64bit)
    libpangocairo-1.0.so.0()(64bit)
    libpangoft2-1.0.so.0()(64bit)
    libpopt.so.0()(64bit)
    libpopt.so.0(LIBPOPT_0)(64bit)
    libpthread.so.0()(64bit)
    libutil.so.1()(64bit)
    rtld(GNU_HASH)



Provides
--------
lttv-devel:
    lttv-devel
    lttv-devel(x86-64)

lttv:
    libbatchAnalysis.so()(64bit)
    libguicontrolflow.so()(64bit)
    libguievents.so()(64bit)
    libguihistogram.so()(64bit)
    liblttvwindow.so()(64bit)
    libresourceview.so()(64bit)
    libtextDump.so()(64bit)
    lttv
    lttv(x86-64)



Unversioned so-files
--------------------
lttv: /usr/lib64/lttv/plugins/libbatchAnalysis.so
lttv: /usr/lib64/lttv/plugins/libguicontrolflow.so
lttv: /usr/lib64/lttv/plugins/libguievents.so
lttv: /usr/lib64/lttv/plugins/libguihistogram.so
lttv: /usr/lib64/lttv/plugins/liblttvwindow.so
lttv: /usr/lib64/lttv/plugins/libresourceview.so
lttv: /usr/lib64/lttv/plugins/libtextDump.so

Source checksums
----------------
Using local file /export/home/orion/redhat/lttv-1.5/lttv-icon.svg as upstream
file:///export/home/orion/redhat/lttv-1.5/lttv-icon.svg :
  CHECKSUM(SHA256) this package     : 0f0b6bae09ca5d9198832acef0ce0effdb470fb1bc803db5fac7e39955824e04
  CHECKSUM(SHA256) upstream package : 0f0b6bae09ca5d9198832acef0ce0effdb470fb1bc803db5fac7e39955824e04
Using local file /export/home/orion/redhat/lttv-1.5/lttv.1 as upstream
file:///export/home/orion/redhat/lttv-1.5/lttv.1 :
  CHECKSUM(SHA256) this package     : 2a4696578f8c364e53a8ce20c186b36de984ca9c7a20b52db43faaff720419a5
  CHECKSUM(SHA256) upstream package : 2a4696578f8c364e53a8ce20c186b36de984ca9c7a20b52db43faaff720419a5
http://www.lttng.org/files/packages/lttv-1.5.tar.bz2 :
  CHECKSUM(SHA256) this package     : 211f8e3f0025e377b3a10689fd450eca072238be7cb2bec12c8db6046d6f54b9
  CHECKSUM(SHA256) upstream package : 211f8e3f0025e377b3a10689fd450eca072238be7cb2bec12c8db6046d6f54b9
Using local file /export/home/orion/redhat/lttv-1.5/lttv.desktop as upstream
file:///export/home/orion/redhat/lttv-1.5/lttv.desktop :
  CHECKSUM(SHA256) this package     : ce5662e30c28e4f71293e6a5cf55c9752a6b98a18653a26efd491c678a57d45e
  CHECKSUM(SHA256) upstream package : ce5662e30c28e4f71293e6a5cf55c9752a6b98a18653a26efd491c678a57d45e
Using local file /export/home/orion/redhat/lttv-1.5/lttv.real.1 as upstream
file:///export/home/orion/redhat/lttv-1.5/lttv.real.1 :
  CHECKSUM(SHA256) this package     : 2cfa968e74991007b61593069e1e560a30b83f116b673bfc0d988be9d4cadc4d
  CHECKSUM(SHA256) upstream package : 2cfa968e74991007b61593069e1e560a30b83f116b673bfc0d988be9d4cadc4d
Using local file /export/home/orion/redhat/lttv-1.5/lttv-gui.1 as upstream
file:///export/home/orion/redhat/lttv-1.5/lttv-gui.1 :
  CHECKSUM(SHA256) this package     : b1dd7b02aa48c79046bdb0f38cbcf0d8ce4fe5f6617f95fab25dfb8e07b83421
  CHECKSUM(SHA256) upstream package : b1dd7b02aa48c79046bdb0f38cbcf0d8ce4fe5f6617f95fab25dfb8e07b83421


Generated by fedora-review 0.5.0 (920221d) last change: 2013-08-30
Command line :/usr/bin/fedora-review -b 1024127
Buildroot used: fedora-19-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, SugarActivity, Perl, R, PHP, Ruby
Disabled flags: EPEL5, EXARCH, DISTTAG
Comment 13 Suchakra 2013-11-08 00:19:39 EST
Hi,

> Do you understand what the changelog is supposed to contain?  Compare to
> other packages with 'rpm -q --changelog <pkgname>'.

Thanks for clarifying. I have changed this appropriately.
 
> - You need to filter the provides of the plugins - see
> https://fedoraproject.org/wiki/Packaging:AutoProvidesAndRequiresFiltering

Did that too. I hope its correct.

> - I've sponsored you.

Thanks :)

> Minor -  
> 
> - you really don't need lttv-devel to require glibc-devel, that's generally
> assumed.
> - Add --disable-silent-rules to %configure - it's good to verify the
> compiler arguments.

I took care of both of them too.

Updated the new spec and SRPM based on Comment 12 :

Spec URL: http://suchakra.fedorapeople.org/packages/lttv.spec
SRPM URL: http://suchakra.fedorapeople.org/packages/lttv-1.5-3.fc19.src.rpm
Comment 14 Orion Poplawski 2013-11-08 11:15:40 EST
mock build fails:

/var/tmp/rpm-tmp.3DCPk9: line 40: desktop-file-install: command not found

You need a BR on desktop-file-utils.  Please test builds in mock first.
Comment 15 Suchakra 2013-11-08 13:58:38 EST
> /var/tmp/rpm-tmp.3DCPk9: line 40: desktop-file-install: command not found
> 
> You need a BR on desktop-file-utils.  Please test builds in mock first.

Changes made. Mock and koji used to test builds : http://koji.fedoraproject.org/koji/taskinfo?taskID=6155876

All seems ok to me.

Updated the new spec and SRPM based on Comment 14 :

Spec URL: http://suchakra.fedorapeople.org/packages/lttv.spec
SRPM URL: http://suchakra.fedorapeople.org/packages/lttv-1.5-4.fc19.src.rpm
Comment 16 Orion Poplawski 2013-11-08 14:18:57 EST
Looks good.  Approved.  Welcome aboard!
Comment 17 Suchakra 2013-11-08 15:13:28 EST
New Package SCM Request
=======================
Package Name: lttv
Short Description: Linux Trace Toolkit Viewer
Owners: suchakra greenscientist
Branches: f19 f20
InitialCC:
Comment 18 Gwyn Ciesla 2013-11-08 15:31:07 EST
Git done (by process-git-requests).
Comment 19 Suchakra 2013-11-08 19:06:09 EST
Thanks everyone. Closing this.
Comment 20 Fedora Update System 2013-11-08 23:46:34 EST
lttv-1.5-4.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/lttv-1.5-4.fc19
Comment 21 Fedora Update System 2013-11-08 23:49:58 EST
lttv-1.5-4.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/lttv-1.5-4.fc20
Comment 22 Fedora Update System 2013-11-13 22:36:19 EST
lttv-1.5-4.fc20 has been pushed to the Fedora 20 stable repository.
Comment 23 Fedora Update System 2013-11-19 00:30:04 EST
lttv-1.5-4.fc19 has been pushed to the Fedora 19 stable repository.

Note You need to log in before you can comment on or make changes to this bug.